# CH32V20X TDD template

## Description

This is a TDD focused template that uses the cpputest testing harness and 
CMAKE for the build system. The build system and testing is held together with
the use of the `otto.sh` script.

## Dependencies

- CMAKE >= 3.20
- CppUTest >= 3.8
- Bash/Sh shell
- wchisp and/or wlink(rust pgrm)


## Hardware Specific

Given this template targets the whole range of CH32V20X chips you will want
to define their memory layout to reflect the chip you have chosen.

## Using the template

### Change project configuration

*Basic Steps:*
1. Change project name parameter in `CMakeLists.txt` in root dir.
2. Edit the memory layout file.


### Setting up dependencies

### Running Tests

```sh
echo "1" | ./otto.sh
```

### Building Binaries


### Flashing Micro-Controller


## TODO

- [ ] check shared libraries build correctly.
- [ ] check if all compile options are same for all parts.
- [ ] Setup linker script inclusion.
- [ ] Add flash target/command.
- [ ] Add size target/command.
- [ ] 
